%global meadalpha %{nil}
%global meadrel %{nil}
%global version_major 1
%global version_minor 6
%global version_micro 1
%global serial 103
%global commitid 07cf4f0b62390e331795b81b2eebeef7e9f86110

%{?scl:%scl_package apr-util}
%{!?scl:%global pkg_name %{name}}


%global _performance_build 1

%define scldir /opt/rh/jbcs-httpd24/root

%define apuver 1
%define soversion 0.6.1


Summary: Apache Portable Runtime Utility library
Name:    %{?scl_prefix}apr-util
Version: 1.6.1
Release: %{serial}%{?dist}
License: ASL 2.0
Group:   System Environment/Libraries
URL:     http://apr.apache.org/
Source0: apr-util-%{commitid}.tar.gz

BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildRequires: autoconf, automake, libtool
BuildRequires: libdb-devel, expat-devel, libuuid-devel
BuildRequires: patchelf
BuildRequires: %{?scl_prefix}apr-devel
BuildRequires: %{?scl_prefix}openssl, %{?scl_prefix}openssl-devel, %{?scl_prefix}openssl-libs

Requires:      %{?scl_prefix}openssl, %{?scl_prefix}openssl-libs
Requires:      %{?scl_prefix}apr


%{?scl:Requires:%scl_runtime}

# Drop private modules from provides
%global __provides_exclude_from %{_libdir}/apr-util-%{apuver}
%global __provides_exclude ^scl-package.*$
%global __requires_exclude ^libapr-1[.]so.*$
%global __requires_exclude %__requires_exclude|^libcrypto[.]so.*$
%global __requires_exclude %__requires_exclude|^libssl[.]so.*$

%description
The mission of the Apache Portable Runtime (APR) is to provide a
free library of C data structures and routines.  This library
contains additional utility interfaces for APR; including support
for XML, LDAP, database interfaces, URI parsing and more.

%package devel
Group:    Development/Libraries
Summary:  APR utility library development kit
Requires: %{?scl_prefix}apr-util%{?_isa} = %{version}-%{release}, %{?scl_prefix}apr-devel%{?_isa}, pkgconfig
Requires: libdb-devel%{?_isa}, expat-devel%{?_isa}, openldap-devel%{?_isa}

%description devel
This package provides the support files which can be used to
build applications using the APR utility library.  The mission
of the Apache Portable Runtime (APR) is to provide a free
library of C data structures and routines.

%package pgsql
Group: Development/Libraries
Summary: APR utility library PostgreSQL DBD driver
BuildRequires: postgresql-devel
Requires: %{?scl_prefix}apr-util%{?_isa} = %{version}-%{release}

%description pgsql
This package provides the PostgreSQL driver for the apr-util
DBD (database abstraction) interface.

%package mysql
Group: Development/Libraries
Summary: APR utility library MySQL DBD driver
%if 0%{?rhel} <= 7
BuildRequires: mysql-devel
%else
BuildRequires: mariadb-connector-c-devel
#BuildRequires: mariadb-devel
%endif
Requires: %{?scl_prefix}apr-util%{?_isa} = %{version}-%{release}

%description mysql
This package provides the MySQL driver for the apr-util DBD
(database abstraction) interface.

%package sqlite
Group: Development/Libraries
Summary: APR utility library SQLite DBD driver
BuildRequires: sqlite-devel >= 3.0.0
Requires: %{?scl_prefix}apr-util%{?_isa} = %{version}-%{release}

%description sqlite
This package provides the SQLite driver for the apr-util DBD
(database abstraction) interface.

%package odbc
Group: Development/Libraries
Summary: APR utility library ODBC DBD driver
BuildRequires: unixODBC-devel
Requires: %{?scl_prefix}apr-util%{?_isa} = %{version}-%{release}

%description odbc
This package provides the ODBC driver for the apr-util DBD
(database abstraction) interface.

%package ldap
Group: Development/Libraries
Summary: APR utility library LDAP support
BuildRequires: openldap-devel
Requires: %{?scl_prefix}apr-util%{?_isa} = %{version}-%{release}

%description ldap
This package provides the LDAP support for the apr-util.

%package openssl
Group: Development/Libraries
Summary: APR utility library OpenSSL crytpo support
BuildRequires: %{?scl_prefix}openssl-devel, %{?scl_prefix}openssl-libs, %{?scl_prefix}openssl
Requires:      %{?scl_prefix}apr-util%{?_isa} = %{version}-%{release}

%description openssl
This package provides the OpenSSL crypto support for the apr-util.

%package nss
Summary: APR utility library NSS crypto support
BuildRequires: nss-devel
BuildRequires: make
Requires: %{?scl_prefix}apr-util%{?_isa} = %{version}-%{release}

%description nss
This package provides the NSS crypto support for the apr-util.

%prep
%setup -q -n %{pkg_name}-%{commitid}

%build
autoheader && autoconf
# A fragile autoconf test which fails if the code trips
# any other warning; force correct result for OpenLDAP:
export ac_cv_ldap_set_rebind_proc_style=three
# export LD_LIBRARY_PATH=%%{scldir}:%%{_libdir}:$LD_LIBRARY_PATH

# Rewrite release number
sed -i "s;\@apu_release_version\@;-%{serial};g" include/apu_version.h

export LDFLAGS="-L%{_libdir} -Wl,-rpath=%{_libdir} -Wl,-z,relro,-z,now"
export CFLAGS="-fPIC -g"

%configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir} \
    --with-apr=%{scldir}/usr \
    --includedir=%{_includedir}/apr-%{apuver} \
    --with-ldap=ldap_r --without-gdbm \
    --with-sqlite3 --with-pgsql --with-mysql --with-odbc \
    --with-berkeley-db=%{scldir}/include:%{_libdir} \
    --without-sqlite2 \
    --with-crypto \
    --with-openssl=%{scldir}/usr \
    --with-nss

make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT/%{_datadir}/aclocal
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/apr-%{apuver}/build
install -m 644 build/find_apu.m4 $RPM_BUILD_ROOT/%{_datadir}/aclocal
install -m 644 build/find_apu.m4 $RPM_BUILD_ROOT/%{_libdir}/apr-%{apuver}/build

# Unpackaged files; remove the static libaprutil
rm -f $RPM_BUILD_ROOT%{_libdir}/aprutil.exp \
      $RPM_BUILD_ROOT%{_libdir}/libapr*.a

# And remove the reference to the static libaprutil from the .la
# file.
sed -i '/^old_library/s,libapr.*\.a,,' \
      $RPM_BUILD_ROOT%{_libdir}/libapr*.la

# Remove unnecessary exports from dependency_libs
sed -ri '/^dependency_libs/{s,-l(pq|sqlite[0-9]|rt|dl|uuid) ,,g}' \
      $RPM_BUILD_ROOT%{_libdir}/libapr*.la

# Trim libtool DSO cruft
rm -f $RPM_BUILD_ROOT%{_libdir}/apr-util-%{apuver}/*.*a

# Run the less verbose test suites
patchelf --set-rpath '$ORIGIN/' $RPM_BUILD_ROOT%{_libdir}/libapr*.so.%{soversion}
for i in $RPM_BUILD_ROOT%{_libdir}/apr-util-%{apuver}/apr_*-1.so ; do
    patchelf --set-rpath '$ORIGIN/../' $i
done

%ifarch x86_64
%check
export MALLOC_CHECK_=2 MALLOC_PERTURB_=$(($RANDOM % 255 + 1))
cd test
make %{?_smp_mflags} testall
# testall breaks with DBD DSO; ignore
export LD_LIBRARY_PATH="`echo "../dbm/.libs:../dbd/.libs:../ldap/.libs:../crypto/.libs:$LD_LIBRARY_PATH" | sed -e 's/::*$//'`"
./testall -v -q || true
./testall testrmm
./testall testdbm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc CHANGES LICENSE NOTICE
%{_libdir}/libaprutil-%{apuver}*.so.*
%dir %{_libdir}/apr-util-%{apuver}
%{_libdir}/libaprutil-%{apuver}*.so
# JBCS-533
%{_libdir}/apr-util-%{apuver}/apr_dbm*.so

%files pgsql
%defattr(-,root,root,-)
%{_libdir}/apr-util-%{apuver}/apr_dbd_pgsql*

%files mysql
%defattr(-,root,root,-)
%{_libdir}/apr-util-%{apuver}/apr_dbd_mysql*

%files sqlite
%defattr(-,root,root,-)
%{_libdir}/apr-util-%{apuver}/apr_dbd_sqlite*

%files odbc
%defattr(-,root,root,-)
%{_libdir}/apr-util-%{apuver}/apr_dbd_odbc*

%files ldap
%defattr(-,root,root,-)
%{_libdir}/apr-util-%{apuver}/apr_ldap*

%files openssl
%defattr(-,root,root,-)
%{_libdir}/apr-util-%{apuver}/apr_crypto_openssl*

%files nss
%defattr(-,root,root,-)
%{_libdir}/apr-util-%{apuver}/apr_crypto_nss*

%files devel
%defattr(-,root,root,-)
%{_bindir}/apu-%{apuver}-config
%{_libdir}/libaprutil-%{apuver}.*a
%{_libdir}/apr-%{apuver}/build/find_apu*
%{_includedir}/apr-%{apuver}/*.h
%{_libdir}/pkgconfig/*.pc
%{_datadir}/aclocal/*.m4

%changelog
* Fri Nov 17 2023 Sokratis Zappis <szappis@redhat.com> - 1.6.1-103
- Build for 2.4.57.SP2

* Tue Aug 01 2023 Mladen Turk <mturk@redhat.com> - 1.6.1-102
- Resolves: #2063562 - mod_auth_openidc fails with IPv6 OIDCMemCacheServers

* Wed May 10 2023 Mladen Turk <mturk@redhat.com> - 1.6.1-101
- Apply fix for CVE-2022-25147

* Thu Apr 27 2023 Sokratis Zappis <szappis@redhat.com> - 1.6.1-100
- Build for 2.4.51.SP2

* Thu Feb 10 2022 Mladen Turk <mturk@redhat.com> - 1.6.1-89
- Remove requirements to openssl libraries

* Thu Feb 10 2022 Mladen Turk <mturk@redhat.com> - 1.6.1-88
- Rebuild wiith updated dependencies

* Wed Feb 09 2022 Mladen Turk <mturk@redhat.com> - 1.6.1-87
- Rebuild wiith updated dependencies

* Fri Feb 04 2022 Mladen Turk <mturk@redhat.com> - 1.6.1-86
- Package for jb-cs-httpd24-51-rhel

* Thu Feb 03 2022 Mladen Turk <mturk@redhat.com> - 1.6.1-85
- Package for jb-cs-httpd24-51-rhel

* Thu Feb 03 2022 Mladen Turk <mturk@redhat.com> - 1.6.1-83
- Package for jb-cs-httpd24-51-rhel
- Use sources from rhel-9.0.0 branch

* Tue Dec 17 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.6.1-54
- JBCS 2.4.37-SP1.ER1

* Wed Sep 25 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.6.1-48
- Building JCBS 2.4.37.ER4

* Wed Sep 25 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.6.1-47
- Building JCBS 2.4.37.ER4

* Fri Sep 20 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.6.1-46
- JBCS httpd 2.4.37.ER3

* Tue Aug 27 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.6.1-45
- Test build

* Tue Aug 06 2019 Dimitris Sartzetakis <dsartzet@redhat.com> - 1.6.1-43
- JBCS 2.4.37.ER2
